<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layoutadmin}">
<head>
    <meta charset="UTF-8">
    <title>TLC</title>
</head>
<body>
<div layout:fragment="main">
    <div class="header bg-gradient-primary pb-8 pt-5 pt-md-8">
        <div class="container-fluid">
            <div class="header-body">
                <!-- Card stats -->
                <div class="row">
                    <div class="col-xl-12 col-lg-12">
                        <div class="card card-stats mb-4 mb-xl-0">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col">
                                        <h5 class="card-title text-uppercase text-muted mb-0">List</h5>
                                        <span class="h2 font-weight-bold mb-0">Periode </span>
                                    </div>
                                    <div class="col-auto">
                                        <div class="icon icon-shape bg-gradient-blue text-white rounded-circle shadow">
                                            <i class="fas fa-sticky-note"></i>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
    <div class="container-fluid mt--7">

        <!-- Table -->
        <div class="row">
            <div class="col-md-5 col-xs-12">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                                <h3 class="mb-0">Form</h3>
                            </div>
                            <div class="col text-right">
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="table-responsive">
                            <table
                                    id="table-jabatan"
                                    data-filter-control="true"
                                    data-search="true"
                                    data-show-refresh="true"
                                    data-pagination="true"
                                    data-side-pagination="server"
                                    data-ajax="ajaxRequestPeriode">
                            </table>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-md-7 col-xs-12" id="div-detail" style="display: none">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <h3 class="mb-0" id="div-judul"></h3>
                        <div class="col text-right">
                            <a id="tambahLink" class="btn btn-sm btn-default"><i
                                    class="fas fa-plus-circle"></i>
                                Tambah Jadwal</a>
                        </div>
                    </div>
                    <div class="card-body">
                        <div class="table-responsive table-striped">
                            <input type="hidden" id="idTahun">
                            <table
                                    id="tableDetail"
                                    data-search="true"
                                    data-show-refresh="true"
                                    data-flat="true"
                                    data-pagination="true"
                                    data-ajax="ajaxRequestJadwal"
                                    data-side-pagination="server">
                            </table>
                        </div>
                    </div>
                </div>
            </div>

            <div class="modal fade" id="tambahModal" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog modal-lg modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Tambah Mahasiswa</h5>
                        </div>
                        <div class="modal-body">
                            <form class="validation" id="update-validation">
                                <div class="card shadow">
                                    <div class="card-body">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label>Mahasiswa</label>
                                                    <select id="mahasiswaList" name="dosen" style="width: 100%!important;"
                                                            class="js-example-basic-multiple js-states form-control js-data-example-ajax">
                                                    </select>
                                                    <div class="invalid-feedback">
                                                        Mahhasiswa Belum Diisi
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="modal-footer">
                                        <button class="btn btn-success" type="button" onclick="tambahMahasiswa()">Simpan</button>
                                        <button onclick="closeModalAdd()" type="button" class="btn btn-danger">Tutup</button>
                                    </div>
                                </div>
                            </form>
                        </div>

                    </div>
                </div>
            </div>

            <div class="col-md-7 col-xs-12" id="div-mahasiswa" style="display: none;">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <h3 class="mb-0"></h3>
                        <div class="col text-right">
                            <button onclick="openModalAdd()"  class="btn btn-sm btn-default"><i
                                    class="fas fa-plus-circle"></i>
                                Tambah Mahasiswa</button>
                        </div>
                    </div>
                    <div class="card-body">
                        <input type="hidden" id="idjadwal">
                        <div class="table-responsive">
                            <table
                                    id="tableMahasiswa"
                                    data-search="true"
                                    data-show-refresh="true"
                                    data-flat="true"
                                    data-pagination="true"
                                    data-ajax="ajaxRequestMahasiswa"
                                    data-side-pagination="server">
                            </table>
                        </div>
                    </div>
                </div>
            </div>

        </div>
        <!-- Dark table -->


    </div>
</div>
</body>
</html>
<script src="https://cdn.jsdelivr.net/npm/flatpickr"></script>
<link href="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/filter-control/bootstrap-table-filter-control.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/auto-refresh/bootstrap-table-auto-refresh.min.js"></script>
<script>

    $("#mahasiswaList").select2(
        {
            dropdownParent: $('#tambahModal'),
            placeholder: 'Cari Dosen',
            multiple: 'true',
            minimumInputLength: 3,
            ajax: {
                url: function (params) {
                    return '/select/mahasiswa?search=' + params.term + '&tahun=' + $('#idTahun').val();
                },
                dataType: 'json',
                type: "GET",
                delay: 300,
                data: function (params) {
                    return {
                        q: params.term
                    };
                },
                processResults: function (data) {
                    for(var i = 0; i < data.length; i++){
                        data[i]={id:data[i].id,text:data[i].nim + ' - ' + data[i].nama,value:data[i].id}
                    }
                    return {
                        results: data
                    };
                }
            },

        });

    function openDetail(args) {
        $("#div-mahasiswa").slideUp("slow");
        document.getElementById("div-mahasiswa").style.display = "none";
        $('#idjadwal').val('')
        document.getElementById("tambahLink").href = "";
        $('#idTahun').val(args.id)
        $tableDetail.bootstrapTable('refresh')
        document.getElementById('div-judul').innerHTML = 'List Jadwal';
        $("#div-detail").slideDown("slow");
        document.getElementById("div-detail").style.display = "block";
        document.getElementById("tambahLink").href = "/tlc/periode/form?tahunAkademik=" + args.id;

    }

    function openMahasiswa(args) {
        $('#idjadwal').val(args.id)
        $("#div-detail").slideUp("slow");
        document.getElementById("div-detail").style.display = "none";
        $tableMahasiswa.bootstrapTable('refresh')
        $("#div-mahasiswa").slideDown("slow");
    }

    var $tableDetail = $('#tableDetail')
    var $tableJabatan = $('#table-jabatan')
    var $tableMahasiswa = $('#tableMahasiswa')

    function openModalAdd(row) {
        $("#tambahModal").modal({
            show: true,
            backdrop: 'static'
        });
    }

    $(function () {
        $tableJabatan.bootstrapTable({
            columns: [
                {
                    field: 'tahun',
                    title: 'Periode',
                    align: 'center',
                    valign: 'middle',
                    sortable: true
                },
                {
                    field: 'operate',
                    title: 'Item Operate',
                    align: 'center',
                    clickToSelect: false,
                    events: window.operateEvents,
                    formatter: operateFormatter
                }]
        })
    })

    $(function () {
        $tableMahasiswa.bootstrapTable({
            columns: [
                {
                    field: 'nim',
                    title: 'Nim',
                    align: 'center',
                    valign: 'middle',
                    sortable: true
                },
                {
                    field: 'nama',
                    title: 'Mahasiswa',
                    align: 'center',
                    valign: 'middle',
                    sortable: true
                },
                {
                    field: 'operate',
                    title: 'Item Operate',
                    align: 'center',
                    clickToSelect: false,
                    events: window.mahasiswaEvent,
                    formatter: mahasiswaFormatter()
                }]
        })
    })

    $(function () {
        $tableDetail.bootstrapTable({
            columns: [
                {
                    field: 'nama',
                    title: 'Matakuliah',
                    align: 'center',
                    valign: 'middle',
                },
                {
                    field: 'kelas',
                    title: 'Kelas',
                    align: 'center',
                    valign: 'middle',
                },
                {
                    field: 'jenis',
                    title: 'Jenis',
                    align: 'center',
                    valign: 'middle',
                },
                {
                    field: 'operate',
                    title: 'Item Operate',
                    align: 'center',
                    clickToSelect: false,
                    events: window.jadwalEvent,
                    formatter: jadwalFormatter()
                }
            ]
        })
    })

    function ajaxRequestJadwal(params) {
        if ($('#idTahun').val() != '') {
            var url = '/tlc/jadwal-list/' + $('#idTahun').val()
            $.get(url + '?' + $.param(params.data)).then(function (res) {
                params.success(res)
            })
        }
    }

    function ajaxRequestMahasiswa(params) {
        if ($('#idjadwal').val() != '') {
            var url = '/tlc/jadwal-mahasiswa/' + document.getElementById('idjadwal').value
            $.get(url + '?' + $.param(params.data)).then(function (res) {
                params.success(res)
            })
        }
    }

    function ajaxRequestPeriode(params) {
        var url = '/tlc/periode-list'
        $.get(url + '?' + $.param(params.data)).then(function (res) {
            params.success(res)
        })
    }

    function operateFormatter(value, row, index) {
        return [
            '<button type="button" class="btn btn-sm btn-info view">',
            '<i class="fas fa-eye view"></i> View',
            '</button>  &nbsp;',
        ].join('')
    }

    function jadwalFormatter(value, row, index) {
        return [
            '<button type="button" class="btn btn-sm btn-info view">',
            '<i class="fas fa-eye view"></i> View',
            '</button>  &nbsp;',
            '<button type="button" class="btn btn-sm btn-success kehadiran">',
            '<i class="fas fa-eye view"></i> Kehadiran',
            '</button>  &nbsp;',
            '<button type="button" class="btn btn-sm btn-primary edit">',
            '<i class="fas fa-edit edit"></i> Edit',
            '</button>  &nbsp;',
            '<button type="button" class="btn btn-sm btn-danger delete">',
            '<i class="fa fa-trash"></i> Hapus',
            '</button>'
        ].join('')
    }

    function mahasiswaFormatter(value, row, index) {
        return [
            '<button type="button" class="btn btn-sm btn-danger delete">',
            '<i class="fa fa-trash"></i> Hapus',
            '</button>'
        ].join('')
    }

    window.operateEvents = {
        'click .view': function (e, value, row, index) {
            openDetail(row);
        }, 'click .edit': function (e, value, row, index) {
            openModal(row.id);
        },
        'click .delete': function (e, value, row, index) {
            deleteJabatan(row.id);
        }
    }

    window.jadwalEvent = {
        'click .view': function (e, value, row, index) {
            openMahasiswa(row);
        },'click .kehadiran': function (e, value, row, index) {
            window.location.href = '/tlc/attendance/detail?id=' + row.id;
        }, 'click .edit': function (e, value, row, index) {
            window.location.href = '/tlc/periode/edit?id=' + row.id;
        },
        'click .delete': function (e, value, row, index) {
            deleteJadwal(row.id);
        }
    }

    window.mahasiswaEvent = {
        'click .view': function (e, value, row, index) {
            openMahasiswa(row);
        }, 'click .edit': function (e, value, row, index) {
            window.location.href = '/tlc/periode/edit?id=' + row.id;
        },
        'click .delete': function (e, value, row, index) {
            deleteMahasiswa(row.id, row.jadwal);
        }
    }

    function simpanJabatan() {
        var request = {};
        var token = $("input[name='_csrf']").val();

        request["nama"] = $('#nama').val();
        request["status"] = $('#status').val();
        request["maksimal"] = $('#maksimal').val();
        request["minimal"] = $('#minimal').val();

        var forms = document.querySelectorAll('.validation');

        Array.prototype.slice.call(forms)
            .forEach(function (form) {
                form.addEventListener('click', function (event) {
                    if (!form.checkValidity()) {
                        event.preventDefault()
                        event.stopPropagation()
                    }
                    form.classList.add('was-validated')
                }, false)
            })

        if ($(".validation")[0].checkValidity()) {
            $.ajax({
                type: "POST",
                contentType: "application/json",
                headers: {"X-CSRF-TOKEN": token},
                url: "/jabatan-post",
                data: JSON.stringify(request),
                dataType: 'json',
                cache: false,
                timeout: 600000,
                success: function (result) {
                    $('#exampleModal').modal('hide');
                    Swal.fire({
                        position: 'top-end',
                        icon: 'success',
                        title: 'Data Sudah Tersimpan ',
                        showConfirmButton: false,
                        timer: 2000
                    })
                    $tableJabatan.bootstrapTable('refresh')
                },
                error: function (result) {

                }
            });
        }
    }

    function updateJabatan() {
        var request = {};
        var token = $("input[name='_csrf']").val();

        request["id"] = $('#id').val();
        request["nama"] = $('#nama').val();
        request["status"] = $('#status').val();
        request["maksimal"] = $('#maksimal').val();
        request["minimal"] = $('#minimal').val();

        var forms = document.querySelectorAll('.validation');

        Array.prototype.slice.call(forms)
            .forEach(function (form) {
                form.addEventListener('click', function (event) {
                    if (!form.checkValidity()) {
                        event.preventDefault()
                        event.stopPropagation()
                    }
                    form.classList.add('was-validated')
                }, false)
            })

        if ($(".validation")[0].checkValidity()) {
            $.ajax({
                type: "PUT",
                contentType: "application/json",
                headers: {"X-CSRF-TOKEN": token},
                url: "/jabatan-update",
                data: JSON.stringify(request),
                dataType: 'json',
                cache: false,
                timeout: 600000,
                success: function (result) {
                    $('#exampleModal').modal('hide');
                    $('.validation').trigger("reset");
                    Array.prototype.slice.call(forms)
                        .forEach(function (form) {
                            form.classList.remove("was-validated");
                        })
                    Swal.fire({
                        position: 'top-end',
                        icon: 'success',
                        title: 'Data Sudah Terupdate ',
                        showConfirmButton: false,
                        timer: 2000
                    })
                    $tableJabatan.bootstrapTable('refresh')
                },
                error: function (result) {

                }
            });
        }
    }

    function deleteMahasiswa(id, jadwal) {
        var token = $("input[name='_csrf']").val();
        var url = "/tlc/periode/delete-mahasiswa/" + jadwal + "/" + id;

        Swal.fire({
            title: 'Anda Yakin Menghapus?',
            text: "Data Akan terhapus secara permanen!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#d33',
            cancelButtonColor: '#3085d6',
            confirmButtonText: 'Ya, Hapus Data!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: url,
                    contentType: "application/json;charset=UTF-8",
                    headers: {"X-CSRF-TOKEN": token},
                    method: 'POST',
                    dataType: 'JSON',
                    success: function (result) {
                        if (result.code == '302') {
                            Swal.fire({
                                position: 'top-end',
                                icon: 'error',
                                title: 'Data Gagal Dihapus',
                                showConfirmButton: false,
                                timer: 2000
                            });
                        } else {
                            Swal.fire({
                                position: 'top-end',
                                icon: 'success',
                                title: 'Data Berhasil Dihapus',
                                showConfirmButton: false,
                                timer: 2000
                            });
                            $tableMahasiswa.bootstrapTable('refresh');
                        }
                    },
                    error: function (result) {
                        alert('error');
                    }
                });
            }
        });
    }

    function deleteJadwal(id) {
        var token = $("input[name='_csrf']").val();
        var url = "/tlc/jadwal/" + id;

        Swal.fire({
            title: 'Anda Yakin Menghapus?',
            text: "Data Akan terhapus secara permanen!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#d33',
            cancelButtonColor: '#3085d6',
            confirmButtonText: 'Ya, Hapus Data!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: url,
                    contentType: "application/json;charset=UTF-8",
                    headers: {"X-CSRF-TOKEN": token},
                    method: 'POST',
                    dataType: 'JSON',
                    success: function (result) {
                        Swal.fire({
                            position: 'top-end',
                            icon: result.code == '302' ? 'error' : 'success',
                            title: result.code == '302' ? 'Data Gagal Dihapus' : 'Data Berhasil Dihapus',
                            showConfirmButton: false,
                            timer: 2000
                        });
                        if (result.code != '302') {
                            $tableDetail.bootstrapTable('refresh');
                        }
                    },
                    error: function () {
                        alert('error');
                    }
                });
            }
        });
    }

    function closeModal() {
        $('#exampleModal').modal('hide');
        $('.validation').trigger("reset");

    }

    $('#closemodal').click(function () {
        $('#exampleModal').modal('hide');
        $('.validation').trigger("reset");
        var forms = document.querySelectorAll('.validation');

        Array.prototype.slice.call(forms)
            .forEach(function (form) {
                form.classList.remove("was-validated");
            })

    });

    function tambahMahasiswa() {

        var request = {};
        var token = $("input[name='_csrf']").val();

        request["idDosen"] = $("#mahasiswaList").val();

        $.ajax({
            type: "POST",
            contentType: "application/json",
            headers: {"X-CSRF-TOKEN": token},
            url: "/jadwal-mahasiswa-post/"+$('#idjadwal').val()+"?mahasiswaList="+$("#mahasiswaList").val(),
            dataType: 'json',
            cache: false,
            timeout: 600000,
            success:function(result) {
                $('#tambahModal').modal('hide');
                $('#mahasiswaList').val('').trigger('change')
                Swal.fire({
                    position: 'top-end',
                    icon: 'success',
                    title: 'Data Tersimpan',
                    showConfirmButton: false,
                    timer: 2000
                })
                $tableMahasiswa.bootstrapTable('refresh')
            },
            error:function(result) {
            }
        });
    }

    function tambahDosen() {

        var request = {};
        var token = $("input[name='_csrf']").val();

        request["idMahasiswa"] = $("#mahasiswaList").val();

        $.ajax({
            type: "POST",
            contentType: "application/json",
            headers: {"X-CSRF-TOKEN": token},
            url: "/jadwal-mahasiswa-post/"+$('#idJadwal').val()+"?mahasiswaList="+$("#mahasiswaList").val(),
            dataType: 'json',
            cache: false,
            timeout: 600000,
            success:function(result) {
                $('#tambahModal').modal('hide');
                $('#mahasiswaList').val('').trigger('change')
                Swal.fire({
                    position: 'top-end',
                    icon: 'success',
                    title: 'Data Tersimpan',
                    showConfirmButton: false,
                    timer: 2000
                })
                $tableDetail.bootstrapTable('refresh')
            },
            error:function(result) {
            }
        });
    }

    function closeModalAdd() {
        $('#tambahModal').modal('hide');
        $('#mahasiswaList').val('').trigger('change')
    }

    flatpickr(".time", {
        mode: range,
        enableTime: true,
        dateFormat: "H:i",
        time_24hr: true
    });
</script>